var base_domain = 'https://';
var base_domain_url = 'api.jijile.net';
// var base_domain_url = 'test.jijile.net';
var globalData = {};
var versionId = '2003';
globalData.domain = base_domain + base_domain_url;
globalData.ttsDomain = "http://tts.jijile.net";
var userinfo = $api.getStorage('userinfo'); //获取本地用户信息
var sessionId = '';
var technicianId = '';
var branchId = '';
if (userinfo != null) {
    sessionId = {
        'sessionId': userinfo.id,
        'Content-Type': 'application/json'
    };
    technicianId = userinfo.technicianId;
    branchId = userinfo.branchId;
}
//格式化日期时间
function formatDate(obj) {
    if (obj < 10) {
        return '0' + obj;
    }
    return obj;
}
//转换时间 兼容国外客户
function transferTime(serveTime, timeStamp) {
    if (!serveTime) {
        //如果服务器没有返回时间
        return '';
    }
    serveTime = serveTime.replace(/-/g, '/');
    var timeZone = Math.abs(new Date().getTimezoneOffset() / 60);
    if (timeZone == 8) {
        //如果是北京时间 直接返回
        if (timeStamp) {
            return new Date(serveTime).getTime();
        }
        return serveTime.replace(/\//g, '-');
    }
    //得到本地时间
    var d = new Date();
    //本地时间与GMT时间的时间偏移差 单位m
    var offset = d.getTimezoneOffset();
    //得到本地时间
    var localTime = new Date(serveTime + '+0800').getTime();
    if (timeStamp) {
        //返回时间戳
        return localTime;
    }
    var nd = new Date(localTime);
    var YY = nd.getFullYear() + '-';
    var MM = formatDate(nd.getMonth() + 1) + '-';
    var dd = formatDate(nd.getDate()) + ' ';
    var hh = formatDate(nd.getHours()) + ':';
    var mm = formatDate(nd.getMinutes()) + ':';
    var ss = formatDate(nd.getSeconds());
    return YY + MM + dd + hh + mm + ss;
}
//如果是调用本地时间去查询
function transferSearchTime(searchTime) {
    searchTime = searchTime.replace(/-/g, '/');
    if (!searchTime) {
        //如果服务器没有返回时间
        return '';
    }
    var timeZone = Math.abs(new Date().getTimezoneOffset() / 60);
    if (timeZone == 8) {
        //如果是北京时间 直接返回
        return searchTime.replace(/\//g, '-');
    }
    //得到本地时间
    var d = new Date();
    //本地时间与GMT时间的时间偏移差 单位m
    var offset = d.getTimezoneOffset();
    //得到本地时间 -480为东8区即北京时间和GMT时间偏移差值
    var localTime = new Date(searchTime).getTime() + (offset - (-480)) * 60000;
    var nd = new Date(localTime);
    var YY = nd.getFullYear() + '-';
    var MM = formatDate(nd.getMonth() + 1) + '-';
    var dd = formatDate(nd.getDate()) + ' ';
    var hh = formatDate(nd.getHours()) + ':';
    var mm = formatDate(nd.getMinutes()) + ':';
    var ss = formatDate(nd.getSeconds());
    return YY + MM + dd + hh + mm + ss;
}
//获取上月营业时间
function getLastMonth(callback) {
    signatureData(globalData.domain + '/branch/' + userinfo.branchId + '/last/month', 'get')
        .then(function(ret) {
            callback(ret.data);
        })
        .catch(function(reject) {
            api.alert({
                title: "操作提示",
                msg: reject.msg
            });
        })
}
//获取本月营业时间
function getCurrentMonth(callback) {
    signatureData(globalData.domain + '/branch/' + userinfo.branchId + '/current/month', 'get')
        .then(function(ret) {
            callback(ret.data);
        })
        .catch(function(reject) {
            api.alert({
                title: "操作提示",
                msg: reject.msg
            });
        })
}
//获取本月时间
function get_current_month(callback) {
    var date = new Date();
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    this.begin = year + '-' + formatDate(month) + '-' + '01' + ' ' + '00:00:00';
    this.end = formatDate(month) == 12 ? (year + 1) + '-' + '01' + '-' + '01' + ' ' + '00:00:00' : year + '-' + formatDate(month + 1) + '-' + '01' + ' ' + '00:00:00';
    callback(this.begin, this.end)
}
//获取上月时间
function get_last_month(callback) {
    var date = new Date();
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    this.begin = formatDate(month - 1) == 0 ? (year - 1) + '-' + '12' + '-' + '31' + ' ' + '23:59:59' : year + '-' + formatDate(month - 1) + '-' + '01' + ' ' + '00:00:00';
    this.end = year + '-' + formatDate(month) + '-' + '01' + ' ' + '00:00:00';
    callback(this.begin, this.end)
}
//获取本月时间
function get_current_month_business() {
    var branch = $api.getStorage('branch');
    var date = new Date();
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var begin = year + '-' + formatDate(month) + '-' + '01' + ' ' + branch.businessHourBegin;
    var end = formatDate(month) == 12 ? (year + 1) + '-' + '01' + '-' + '01' + ' ' + branch.businessHourEnd : year + '-' + formatDate(month + 1) + '-' + '01' + ' ' + branch.businessHourEnd;
    return [begin, end]
}
//获取上月时间
function get_last_month_business() {
    var branch = $api.getStorage('branch');
    var date = new Date();
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var begin = formatDate(month) == '01' ? (year - 1) + '-' + '12' + '-' + '01' + ' ' + branch.businessHourBegin : year + '-' + formatDate(month - 1) + '-' + '01' + ' ' + branch.businessHourBegin;
    var end = year + '-' + formatDate(month) + '-' + '01' + ' ' + branch.businessHourEnd;
    return [begin, end]
}
//获取门店设置数据
function branchData(callback) {
    signatureData(globalData.domain + '/branch/' + branchId, 'get')
        .then(function(ret) {
            callback(ret.data)
        })
        .catch(function(reject) {
            api.alert({
                title: '提示',
                msg: reject.msg,
            }, function(ret, err) {

            });
        })
}

//云打印
function cloudPrint(payId) {
    signatureData(globalData.domain + '/order/pay/' + payId + '/cloudPrint', 'get')
        .then(function(ret) {
          api.toast({
              msg: '打印成功',
              duration: 2000,
              location: 'bottom'
          });
        })
        .catch(function(reject) {
            api.alert({
                title: '提示',
                msg: reject.msg,
            }, function(ret, err) {});
        })
}

//时间戳转日期
function timestampToTime(timestamp) {
    var date = new Date(timestamp); //时间戳为13位的
    Y = date.getFullYear() + '-';
    M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
    D = formatDate(date.getDate()) + ' ';
    h = formatDate(date.getHours()) + ':';
    m = formatDate(date.getMinutes()) + ':';
    s = formatDate(date.getSeconds());
    return Y + M + D + h + m + s;
}
function openSerchItemFrm(objects,title,lineNum){
    api.openFrame({
    name: 'search_item_frm',
        url: api.wgtRootDir + '/html/public/search_item_frm.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        bounces: false,
        pageParam: {
            projects: objects,
            title: title,
            line: lineNum||3
        },
        bgColor: 'rgba(0,0,0,0.7)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false
    });
}
function openLock() {
    api.openFrame({
        name: 'lock_component_win',
        url: api.wgtRootDir + '/html/lockScreen/lock_component_win.html',
        rect: {
            x: 0,
            y: 0,
            w: api.winWidth,
            h: api.winHeight
        },
        pageParam: {
            name: 'test'
        }
    });

}
//关闭窗口
function closeWin() {
    api.closeWin({});
}

//监听关闭推送节点元素
function listenerTipClose() {
    api.addEventListener({
        name: 'closeTips'
    }, function(ret, err) {
        api.closeFrame({
            name: 'tip_frm'
        });
    });

}
//以下为加签名写法
function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);

}

function uuid() {
    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function parseURL(url) {
    function getQuery() {
        var start = url.indexOf("?");
        if (start == -1)
            return "";
        return url.substr(start + 1);
    }

    return {
        source: url,
        host: (function() {
            var start = url.indexOf("//");
            var end = url.indexOf("/", start + 2);
            return url.substr(start + 2, end - start - 2);
        }),
        page: (function() {
            var start = url.indexOf("//");
            var start1 = url.indexOf("/", start + 2);
            if (url.indexOf("?") == -1) {
                return url.substr(start1)
            } else {
                var end1 = url.indexOf("?");
                return url.substr(start1, end1 - start1);
            }
        }),
        params: (function() {
            var ret = {},
                seg = getQuery(url).split('&'),
                len = seg.length,
                i = 0,
                s;
            for (; i < len; i++) {
                if (!seg[i]) {
                    continue;
                }
                s = seg[i].split('=');
                ret[s[0]] = s[1];
            }
            return ret;
        })
    }
}

if (window.Promise == undefined) {
    window.Promise = function(processor) {
        var self = this;
        self.status = 'pending'; // status
        self.value = null; // resolve value
        self.reason = null; // reject reason
        self.onRejectedCallbacks = []; // reject callback
        self.onFulfilledCallbacks = []; // resolve callback

        // resolve //
        function resolve(value) {
            if (self.status === 'pending') {
                self.status = 'fulfilled';
                self.value = value;
                self.onFulfilledCallbacks.map(function(callback) {
                    callback();
                });
            }
        }
        // reject //
        function reject(reason) {
            if (self.status === 'pending') {
                self.status = 'rejected';
                self.reason = reason;
                self.onRejectedCallbacks.map(function(callback) {
                    callback(reason);
                });
            }
        }

        // delay to next event loop //
        try {
            processor(resolve, reject);
        } catch (e) {
            setTimeout(function() {
                reject(e);
            });
        }
    }

    /* ------------------- 分析promise.then中返回的值类型 promise/value ------------------- */
    /**
     * [analysisPromise 使用递归将状态控制权转移]
     * @param  {[Any]} x        [value]
     * @param  {[Func]} resolve [get into success state]
     * @param  {[Func]} reject  [get into faill state]
     */
    var analysisPromise = function(x, resolve, reject) {

        var then, y;
        if (x !== undefined && (typeof x === 'object' || typeof x === 'function')) {
            then = x.then;
            // obj Promise
            if (then && typeof then === 'function') {
                then.call(x, function(value) {
                    // callback return a promise
                    analysisPromise(value, resolve, reject);
                }, function(error) {
                    reject(error);
                });
                // normal
            } else {
                resolve(x);
            }
            // normal
        } else {
            resolve(x);
        }
    };

    /* ------------------- then-返回新的promise ------------------- */
    /**
     * [then 应该返回一个全新的Promise对象，不应该与当前Promise存在功能耦合]
     * @param  {[type]} successFn [description]
     * @param  {[type]} errorFn   [description]
     */
    Promise.prototype.then = function(successCallback, errorCallback) {

        var promise, x;
        var self = this;

        if (self.status === 'fulfilled') {
            promise = new Promise(function(resolve, reject) {
                // delay to next event loop
                setTimeout(function() {
                    try {
                        x = successCallback(self.value);
                        analysisPromise(x, resolve, reject);
                    } catch (e) {
                        reject(e);
                    }
                });
            });
        } else if (self.status === 'rejected') {
            promise = new Promise(function(resolve, reject) {
                // delay to next event loop
                setTimeout(function() {
                    try {
                        x = errorCallback(self.reason);
                        analysisPromise(x, resolve, reject);
                    } catch (e) {
                        reject(e);
                    }
                });

            });
        } else if (self.status === 'pending') {
            promise = new Promise(function(resolve, reject) {

                // 延迟到下一个事件循环
                setTimeout(function() {
                    self.onFulfilledCallbacks.push(function() {
                        try {
                            x = successCallback(self.value);
                            // 分析返回值 然后更改 当前promise状态
                            analysisPromise(x, resolve, reject);
                        } catch (e) {
                            reject(e);
                        }
                    });

                    self.onRejectedCallbacks.push(function() {
                        try {
                            x = errorCallback ? errorCallback(self.reason) : undefined;
                            // 分析返回值 然后更改 当前promise状态
                            analysisPromise(x, resolve, reject);
                        } catch (e) {
                            reject(e);
                        }
                    });
                })
            });

        }

        return promise;
    };


    /* ------------------- 错误捕获 ------------------- */
    Promise.prototype.catch = function(handleError) {
        if (this.status === 'pending') {
            this.onRejectedCallbacks.push(handleError);
        } else {
            this.reason && handleError(this.reason);
        }
    };
}
//自行约定type=1用body传值,type=2为websocket请求只需要转换地址type=3为传图片否则用files传值
function signatureData(url, method, data, type, useSecretKey) {
    useSecretKey = useSecretKey === false ? false :true;
    if(url.indexOf('.net')>-1){
        url = globalData.domain + url.split('.net')[1];
    }
    if (typeof(data) == 'object' && data != null && type != 3) {
        data = JSON.stringify(data);
    }
    var session = $api.getStorage('userinfo');
    // if (session && session.apiUrl && !islogin) { //灰度
    //     var apiUrl = session.apiUrl;
    //     if (base_domain === 'http://') {
    //         url = url.replace(/test.jijile.net/i, apiUrl)
    //     } else if (base_domain === 'https://') {
    //         url = url.replace(/api2.jijile.net/i, apiUrl)
    //     }
    // }
    var newUrl;
    var thisSession = '';
    if (session != null && type != 3) {
        thisSession = {
            'branchId' : session.branchId,
            'sessionId': session.id,
            'Content-Type': 'application/json',
            'versionId': versionId,
            // 'deviceId': api.deviceId,
        }
    } else if (session != null && type == 3) {
        thisSession = {
            'branchId' : session.branchId,
            'sessionId': session.id
        };
    } else {
        thisSession = {
            // deviceId: api.deviceId,
            'versionId': versionId
        };
    }
    if (data == '' || data == null || data == undefined) {
        if (url.indexOf("?") > 0) {
            newUrl = url + '&timestamp=' + new Date().getTime() + '&nonce=' + uuid();
        } else {
            newUrl = url + '?timestamp=' + new Date().getTime() + '&nonce=' + uuid();
        }
    } else {
        var bodysign;
        if (session && session.secretKey && useSecretKey) {
            bodysign = sha256(data + session.secretKey);
        } else {
            bodysign = sha256(data);
        }
        if (url.indexOf("?") > 0) {
            newUrl = url + '&timestamp=' + new Date().getTime() + '&nonce=' + uuid() + "&bodySign=" + bodysign;
        } else {
            newUrl = url + '?timestamp=' + new Date().getTime() + '&nonce=' + uuid() + "&bodySign=" + bodysign;
        }
    }
    var params = parseURL(newUrl).params();
    var apiUrl = parseURL(newUrl).host() + parseURL(newUrl).page();
    var keys = new Array();
    for (var key in params) {
        if (params.hasOwnProperty(key)) {
            keys.push(key)
        }
    }
    keys.sort();
    newUrl = apiUrl + "?";
    for (var i = 0; i < keys.length; i++) {
        if (keys[i].indexOf("begin") >= 0 && params[keys[i]].length == 19) { //时间国际化处理
            params[keys[i]] = transferSearchTime(params[keys[i]]);
        } else if (keys.indexOf("end") >= 0 && params[keys[i]].length == 19) {
            params[keys[i]] = transferSearchTime(params[keys[i]]);
        }
        if (i < keys.length - 1)
            newUrl = newUrl + keys[i] + "=" + params[keys[i]] + "&";
        else
            newUrl = newUrl + keys[i] + "=" + params[keys[i]];
    }
    var sign;
    if (session && session.secretKey && useSecretKey) {
        sign = sha256(newUrl.split('.net')[1] + session.secretKey);
    } else {
        sign = sha256(newUrl.split('.net')[1]).toString();
    }
    var sinUrl = base_domain + base_domain_url + newUrl.split('.net')[1] + "&sign=" + sign;
    //type=2为websocket请求
    if (type == 2) {
        return sinUrl;
    }
    var messageType = {};
    if (type == 1 && data != '') {
        messageType.body = data;
    } else if (type != 1 && data != '') {
        messageType.files = data
    }
    var promise = new Promise(function(resolve, reject) {
        api.ajax({
            url: sinUrl,
            method: method,
            headers: thisSession,
            data: messageType
        }, function(ret, err) {
            api.hideProgress();
            if (ret) {
                if (ret.code == 0) {
                    resolve(ret);
                } else {
                    if (ret.code == 10010) {
                        $api.rmStorage('userinfo'); //清除用户信息
                        var jsfun = 'stopPush();';
                        api.execScript({
                            name: 'root',
                            script: jsfun
                        });
                        api.rebootApp();
                    }
                    reject(ret);
                }
            } else {
                reject({
                    msg: '服务端繁忙！请稍后操作'
                });
            }
        });
    })
    return promise;
}

//type=3file传值
function signatureDataNoProgress(url, method, data, headers, type,useSecretKey) {
    useSecretKey = useSecretKey === false ? false :true;
    if(url.indexOf('.net')>-1){
        url = globalData.domain + url.split('.net')[1];
    }
    if (typeof(data) == 'object') {
        data = JSON.stringify(data);
    }
    var newUrl;
    var session = $api.getStorage('userinfo');
    // if (session && session.apiUrl) { //灰度
    //     var apiUrl = session.apiUrl;
    //     if (base_domain === 'http://') {
    //         url = url.replace(/test.jijile.net/i, apiUrl)
    //     } else if (base_domain === 'https://') {
    //         url = url.replace(/api2.jijile.net/i, apiUrl)
    //     }
    // }
    if (data == '' || data == null || data == undefined) {
        if (url.indexOf("?") > 0) {
            newUrl = url + '&timestamp=' + new Date().getTime() + '&nonce=' + uuid();
        } else {
            newUrl = url + '?timestamp=' + new Date().getTime() + '&nonce=' + uuid();
        }
    } else {
        var bodysign;
        if (session) {
            bodysign = sha256(data + session.secretKey);
        } else {
            bodysign = sha256(data);
        }
        if (url.indexOf("?") > 0) {
            newUrl = url + '&timestamp=' + new Date().getTime() + '&nonce=' + uuid() + "&bodySign=" + bodysign;
        } else {
            newUrl = url + '?timestamp=' + new Date().getTime() + '&nonce=' + uuid() + "&bodySign=" + bodysign;
        }
    }
    var params = parseURL(newUrl).params();
    var apiUrl = parseURL(newUrl).host() + parseURL(newUrl).page();
    var keys = new Array();
    for (var key in params) {
        if (params.hasOwnProperty(key)) {
            keys.push(key)
        }
    }
    keys.sort();
    newUrl = apiUrl + "?";
    for (var i = 0; i < keys.length; i++) {
        if (keys[i].indexOf("begin") >= 0 && params[keys[i]].length == 19) { //时间国际化处理
            params[keys[i]] = transferSearchTime(params[keys[i]]);
        } else if (keys.indexOf("end") >= 0 && params[keys[i]].length == 19) {
            params[keys[i]] = transferSearchTime(params[keys[i]]);
        }
        if (i < keys.length - 1)
            newUrl = newUrl + keys[i] + "=" + params[keys[i]] + "&";
        else
            newUrl = newUrl + keys[i] + "=" + params[keys[i]];
    }
    var sign;
    if (session && session.secretKey) {
        sign = sha256(newUrl.split('.net')[1] + session.secretKey)
    } else {
        sign = sha256(newUrl.split('.net')[1])
    }
    var sinUrl = base_domain + base_domain_url + newUrl.split('.net')[1] + "&sign=" + sign;
    var promise = new Promise(function(resolve, reject) {
        var options = {
            url: sinUrl,
            method: method,
        }
        var sendHeader = headers || {};
        if (session) {
            sendHeader.sessionId = session.id;
            sendHeader.branchId = session.branchId;
        };
        sendHeader.versionId = versionId;
        options.headers = sendHeader;
        if (data) {
            if (type == 3) {
                options.data = {
                    files: data
                };
            } else {
                options.data = {
                    body: data
                };
            }
        }
        api.ajax(options, function(ret, err) {
            api.hideProgress();
            if (ret) {
                if (ret.code == 0) {
                    resolve(ret);
                } else {
                    if (ret.code == 10010) {
                        $api.rmStorage('userinfo'); //清除用户信息
                        var jsfun = 'stopPush();';
                        api.execScript({
                            name: 'root',
                            script: jsfun
                        });
                        api.rebootApp();
                    }
                    reject(ret);
                }
            } else {
                reject(err);
            }
        });
    })
    return promise;
}


//动态权限
function hasPermission(one_per) {
    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    } else {
        perms = ['location', 'photos', 'notification']
    }
    var rets = api.hasPermission({
        list: perms
    });
    if (!one_per) {
        var str = '请求结果：';
        for (var i = 0; i < rets.length; i++) {
            if(!rets[i].granted){
              api.confirm({
                  msg: '应用需要您的'+checkPermissionName(rets[i].name)+'授权',
                  buttons: ['取消', '去设置']
              }, function(ret) {
                  if (ret.buttonIndex == 2) {
                    reqPermission();
                  }
              })
              return rets
            }
            str += checkPermissionName(rets[i].name) + ':' + (rets[i].granted?'开启;':'关闭;');
        }
        api.toast({
            msg: str,
            duration: 3000,
            location: 'middle'
        });
    }
    return rets
}

function checkPermissionName(permissionName) {
    if (!permissionName) {
        return;
    }
    var newPermissionName = '';
    switch (permissionName) {
        case 'storage':
            newPermissionName = '存储权限';
            break;
        case 'photos':
            newPermissionName = '相册权限';
            break;
        case 'notification':
            newPermissionName = '通知权限';
            break;
        case 'location':
            newPermissionName = '定位权限';
            break;
        default:
            newPermissionName = '未知权限';
    }
    return newPermissionName
}

function reqPermission(one_per, callback) {
    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    } else {
        perms = ['location', 'photos', 'notification']
    }
    api.requestPermission({
        list: perms,
        code: 100001
    }, function(ret, err) {
        if (ret && callback) {
            callback(ret);
            return;
        }
        // var str = '请求结果：\n';
        // str += '请求码: ' + ret.code + '\n';
        // str += "是否勾选\"不再询问\"按钮: " + (ret.never ? '是' : '否') + '\n';
        // str += '请求结果: \n';
        // var list = ret.list;
        // for(var i in list){
        // 	str += list[i].name + '=' + list[i].granted + '\n';
        // }
        // api.toast({
        //     msg: str,
        //     duration: 2000,
        //     location: 'bottom'
        // });
    });
}

function goRoot() {
    setTimeout(function() {
        api.closeToWin({
            name: 'root'
        });
    }, 1000);
}

//tts签名
function ttsSignatureData(url, method, pathName) {
    var newUrl;
    if (url.indexOf("?") > 0) {
        newUrl = url + '&timestamp=' + new Date().getTime() + '&nonce=' + uuid();
    } else {
        newUrl = url + '?timestamp=' + new Date().getTime() + '&nonce=' + uuid();
    }
    var params = parseURL(newUrl).params();
    var apiUrl = parseURL(newUrl).host() + parseURL(newUrl).page();
    var keys = new Array();

    for (var key in params) {
        if (params.hasOwnProperty(key)) {
            keys.push(key)
        }
    }
    keys.sort();
    newUrl = "/tts?";
    for (var i = 0; i < keys.length; i++) {
        if (i < keys.length - 1) {
            newUrl = newUrl + keys[i] + "=" + params[keys[i]] + "&";
        } else {
            newUrl = newUrl + keys[i] + "=" + params[keys[i]];
        }
    }
    var sign = sha256(newUrl);
    newUrl = newUrl + "&sign=" + sign;
    newUrl = globalData.ttsDomain + newUrl;
    var promise = new Promise(function(resolve, reject) {
        api.getFreeDiskSpace(function(ret, err) {
            if (ret) {
                var size = ret.size;
                if (size > 500000) {
                    api.download({
                        url: newUrl,
                        savePath: 'fs://' + pathName,
                        report: true,
                        cache: true,
                        allowResume: true
                    }, function(ret, err) {
                        if (ret && ret.state) {
                            api.startPlay({
                                path: 'fs://' + pathName,
                            }, function(ret, err) {
                                if (err) {
                                    reject({
                                        msg: '语音合成失败'
                                    })
                                }
                            });
                        }
                        if (err) {
                            reject({
                                msg: '语音下载失败'
                            })
                        }
                    });
                } else {
                    reject({
                        msg: '存储空间不足'
                    })
                }
            }
            if (err) {
                reject({
                    msg: '查询剩余空间失败'
                })
            }
        });
    })
    return promise;
}
function accMul(arg1, arg2) {        
    var m = 0,
        s1 = arg1.toString(),
        s2 = arg2.toString();        
    try {
        m += s1.split(".")[1].length
    } catch (e) {}        
    try {
        m += s2.split(".")[1].length
    } catch (e) {}                
    return Number((Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)).toFixed(2));   
}

function accDiv(arg1, arg2) {
    var t1 = 0,
        t2 = 0,
        r1, r2;
    try {
        t1 = arg1.toString().split(".")[1].length
    } catch (e) {} //--小数点后的长度
    try {
        t2 = arg2.toString().split(".")[1].length
    } catch (e) {} //--小数点后的长度
    r1 = Number(arg1.toString().replace(".", "")) //--去除小数点变整数
    r2 = Number(arg2.toString().replace(".", "")) //--去除小数点变整数
    return Number(((r1 / r2) * Math.pow(10, t2 - t1)).toFixed(2)); //---整数相除 在乘上10的平方  小数点的长度
}

function sumPlus() {
    var len = arguments.length;
    if (len < 2) return;
    var sum = 0;
    for (var i = 0; i < len; i++) {
        sum += accMul(arguments[i], 1000);
    }
    return accDiv(sum , 1000);
}

function sumMinus() {
    var len = arguments.length;
    if (len < 2) return;
    var sum = accMul(arguments[0], 1000);
    for (var i = 1; i < len; i++) {
        sum -= accMul(arguments[i], 1000);
    }
    return accDiv(sum , 1000);
}
function getDistinct(newVla,oldVla) {//wathc 比较oldVla newVla 两个数组中变动的值
    var arr = [];
    var arr1 = oldVla.length>newVla.length?oldVla:newVla;
    var arr2 = oldVla.length>newVla.length?newVla:oldVla;
    for (var i = 0; i < arr1.length; i++) {
        var obj1 = arr1[i]
        var isExist = false;
        for (var j = 0; j < arr2.length; j++) {
            var obj2 = arr2[j]
            if (obj1 == obj2) {
                isExist = true;
                break;
            }
        }
        if (!isExist) {
            arr.push(obj1)
        }
    }
    return arr;
}
function unique(arr){
   var newArr = [];
   for (var i = 0 , len = arr.length ; i < len; i++) {
     if(newArr.indexOf(arr[i]) === -1){
       newArr.push(arr[i]);
     }
   }
   return newArr;
}
